
local M = {}

local timer = 0;

local variables
	
	local red
	local green
	local blue
	local aniSpeed
	
	local aniStepRed = 0
	local aniStepGreen = 0
	local aniStepBlue = 0

local function onInit()
	obj.debugDrawProxy:drawColTris(0, color(0,0,0,150), color(200,200,0,255), color(100,0,0,50), 1, color(0,0,255,255))

	variables = v.data.variables
	--Get the RGB values
	for x,y in pairs(variables) do
		for i,v in pairs(y) do
			
			if v == "$1red" then
				aniStepRed = y.val / 162.338041954
			end
			if v == "$2green" then
				aniStepGreen = y.val / 162.338041954
			end
			if v == "$3blue" then
				aniStepBlue = y.val / 162.338041954
			end
			if v == "$animate" then
				aniSpeed = y.val
			end
		end
	end
end

local function onReset()
    onInit()
end

local function updateGFX(dt)

	--Figure out animation
	aniStepRed = aniStepRed + (dt * aniSpeed)
	aniStepGreen = aniStepGreen + (dt * aniSpeed)
	aniStepBlue = aniStepBlue + (dt * aniSpeed)
	
	--Clamp RGB values
	if aniStepRed > 3.14159265359 then
		aniStepRed = 0
	end
	if aniStepGreen > 3.14159265359 then
		aniStepGreen = 0
	end
	if aniStepBlue > 3.14159265359 then
		aniStepBlue = 0
	end
	
	red = 255 * math.sin(aniStepRed)
	green = 255 * math.sin(aniStepGreen)
	blue = 255 * math.sin(aniStepBlue)
	
	

	

	-- simply draw all beams in pink
	for _, beam in pairs (v.data.beams) do
		obj.debugDrawProxy:drawBeam3d(beam.cid, 0.01, color(0, 0, 0,255))
	end

	obj.debugDrawProxy:drawColTris(0, color(red,green,blue,255), color(red,green,blue,255), color(red,green,blue,255), 1, color(red,green,blue,255))

end

-- public interface
M.onInit    = onInit
M.onReset   = onReset
M.updateGFX = updateGFX

return M